using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{

    protected void Page_Load(object sender, EventArgs e)
    {

    }

    private IAsyncResult BeginAsyncOperation1(object sender, EventArgs e,AsyncCallback cb, object state)
    {
        System.IO.StreamWriter writer= System.IO.File.AppendText(Server.MapPath("log1.txt"));
        writer.WriteLine(DateTime.Now);
        writer.Close();

        WSProxy1.WebService1 obj1 = (WSProxy1.WebService1)state;
        obj1 = new WSProxy1.WebService1();
        return obj1.BeginHelloWorld("Tom",cb, state);
    }

    private void EndAsyncOperation1(IAsyncResult ar)
    {
        System.IO.StreamWriter writer = System.IO.File.AppendText(Server.MapPath("log1.txt"));
        writer.WriteLine(DateTime.Now);
        writer.Close();

        WSProxy1.WebService1 obj1 = (WSProxy1.WebService1)ar.AsyncState;
        Label1.Text = Label1.Text + "<br>" + obj1.EndHelloWorld(ar);
    }

    private void TimeoutAsyncOperation1(IAsyncResult ar)
    {
        //do nothing
    }

    private IAsyncResult BeginAsyncOperation2(object sender, EventArgs e, AsyncCallback cb, object state)
    {
        System.IO.StreamWriter writer= System.IO.File.AppendText(Server.MapPath("log2.txt"));
        writer.WriteLine(DateTime.Now);
        writer.Close();

        WSProxy2.WebService2 obj2 = (WSProxy2.WebService2)state;
        obj2 = new WSProxy2.WebService2();
        return obj2.BeginHelloWorld("Jerry",cb, state);
    }

    private void EndAsyncOperation2(IAsyncResult ar)
    {
        System.IO.StreamWriter writer = System.IO.File.AppendText(Server.MapPath("log2.txt"));
        writer.WriteLine(DateTime.Now);
        writer.Close();

        WSProxy2.WebService2 obj2 = (WSProxy2.WebService2)ar.AsyncState;
        Label1.Text = Label1.Text + "<br>" + obj2.EndHelloWorld(ar);
    }

    private void TimeoutAsyncOperation2(IAsyncResult ar)
    {
        //do nothing
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        WSProxy1.WebService1 obj1=new WSProxy1.WebService1();
        WSProxy2.WebService2 obj2=new WSProxy2.WebService2();

        BeginEventHandler beginHandler1 = new BeginEventHandler(BeginAsyncOperation1);
        EndEventHandler endHandler1 = new EndEventHandler(EndAsyncOperation1);
        EndEventHandler timeoutHandler1 = new EndEventHandler(TimeoutAsyncOperation1);
        object state1 = obj1;
        PageAsyncTask task1 = new PageAsyncTask(beginHandler1, endHandler1, timeoutHandler1, state1,true);

        BeginEventHandler beginHandler2 = new BeginEventHandler(BeginAsyncOperation2);
        EndEventHandler endHandler2 = new EndEventHandler(EndAsyncOperation2);
        EndEventHandler timeoutHandler2 = new EndEventHandler(TimeoutAsyncOperation2);
        object state2 = obj2;
        PageAsyncTask task2 = new PageAsyncTask(beginHandler2, endHandler2, timeoutHandler2, state2,true);

        Page.RegisterAsyncTask(task1);
        Page.RegisterAsyncTask(task2);
    }
}
